;Z80 Assembly Programmers Organization (ZAPO)
;Even faster findpixel routine
;~Code7~
;
;102 t-states
;30 bytes
;not counting optional return
;
;Input:
;b=x
;c=y
;
;Output:
;hl = byte in LCD memory
;a = bitmask for (hl)
;de destroyed
;
;if you use a=x and c=y for input and use the
;shorter version (FindPixelShort), then this routine
;takes only 98 t-states but will destroy your x value
;
;Feb 16,1999



;the start of this offset table program must be placed where
;the first hex digit is a 0, 4, 8 or C and the second hex digit
;of the address is a 7.  It must also be on an 8 byte boudary
;examples would be $0700-$07f8, and $8700-$87f8, unfortunately
;some of these these are in the rom. Copy the table to the location
;you wish, out of those mentioned above to get this to run, I've
;included an initialization routine to move it to $8700 below

Offset: .db $80,$40,$20,$10,$8,$4,$2,$1

;end offset table


;the find pixel routine itself can be placed anywhere
FindPixel:
	ld a,b
FindPixelShort:
	ld h,$3f
	add a,a
	add a,a
	ld l,a
	add hl,hl
	add hl,hl
	ld a,c
	rra
	rra
	rra
	add a,l
	ld l,a
	ld de,Offset
	ld a,c
	and d
	or e
	ld e,a
	ld a,(de)

	ret

InitializeFP:	;11 bytes, 59 t-states, not including optional ret
	ld de,$8700
	ld hl,Offset
	ld bc,8
	ldir

	ret

.end
